{
    RED [true]
    BACK [panel01]
    NEXT [panel02]
    TM [0]
    UKEY [20]
    NC [0]
    DIFTIME [1]
    LEVELTIME [0]
    LC [0]
    NEXTKEY [HackItKey2]
    KEY {
            {
                Number[0]
                Text [ ]
            }
            {
                Number[0]
                Text [ ]
            }
            {
                Number[0]
                Text [ ]
            }
            {
                Number[0]
                Text [ ]
            }
        }

    
    Spawn[()
    {
        Console(false);
        LowLevel("Setup");
    }]
    
    Setup[()
    {
        PawnRender(false);
        self.think="ShowTime";
        LEVELTIME = 600 - self.DifficultyLevel*60;
        DIFTIME = 1.25 - self.DifficultyLevel * 0.25;
        StopAllAudioStreams();
        LC = self.time;
    }]
    
    ShowTime[()
    {
        DrawText("Make it to the Reactor Room",300,250,255.0,7,255,255,255);
        DrawText("You've got " # Integer(LEVELTIME / 60) # " Minutes",350,270,255.0,7,255,255,255);
        if(self.time > LC+15)
        {
            self.think="panel01";
            StartSoundtrack("rock02.ogg");
            LC = self.time;
        }
    }]
    
    panel01[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        if(GetEventState("panel01touch"))
        {
            self.think="StartHack";
            BACK="panel01";
            NEXT="panel02";
            TM = self.time;
        }
        if(GetEventState("tel01messagetrig"))
        {
            DrawText("Remote Hack the Panel to Activate the Teleporter",200,250,255.0,7,255,255,255);
        }
    }]
    
    panel02[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        if(GetEventState("panel02touch"))
        {
            self.think="StartHack";
            BACK="panel02";
            NEXT="panel04";
            TM = self.time;
        }
        
        if(GetEventState("trip2trig"))
        {
            DrawText("Remote Hack the Panel to Activate the Teleporter",200,250,255.0,7,255,255,255);
        }
    }]
    
    panel04[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        if(GetEventState("panel04touch"))
        {
            self.think="StartHack";
            BACK="panel04";
            NEXT="panel05";
            TM = self.time;
        }
    }]
    
    panel05[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        if(GetEventState("panel05touch"))
        {
            self.think="StartHack";
            BACK="panel05";
            NEXT="EndLevel";
            TM = self.time;
        }
    }]
    
    EndLevel[()
    {
        DrawText("Overload in Progress",200,200,255.0,8,255,255,255);        
    }]
    
    StartHack[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        DrawText("Press U to Remote Hack Panel",280,250,255.0,7,255,255,255);
        if(self.time > TM + 5)
        {
            self.think=BACK;
            return 0;
        }
        if(IsKeyDown(UKEY))
        {
            // set the key
            KEY[0].Number = random(1,9);
            NC = 1;
            TM = self.time;
            self.think="HackItKey1";
            return 0;
        }
    }]
    
    HackItKey1[()
    {
        PositionToPlayer(0,0,0,false);
        if(not DrawTime()){self.think="TimeOut";return 0;}
        // see if current number matches random number
        if(Integer(NC) != KEY[0].Number){RED = true;}
        else
        {
            RED = false;
            //see if current number is pressed
            if(self.key_pressed = KEY[0].Number)
            {
                PlaySound("button2.wav");
                // set the text
                KEY[0].Text = StringCopy(KEY[0].Number);
                // set the next random number
                KEY[1].Number = random(1,9);
                // got to next number
                NEXTKEY="HackItKey2";
                self.think="KeyDelay";
                TM = self.time;
                return 0;
            }
        }

        if(self.key_pressed > -1)
        {
            PlaySound("button1.wav");
            self.think="HackItKey1";
        }
        
        if(RED){DrawText(Integer(NC),100,250,255.0,8,255,255,255);}
        else{DrawText(Integer(NC),100,250,255.0,9,255,255,255);}
        
        DrawText("X",120,250,255.0,8,255,255,255);
        DrawText("X",140,250,255.0,8,255,255,255);
        DrawText("X",160,250,255.0,8,255,255,255);
        DrawText("Press Green Key",100,280,255.0,7,255,255,255);
        
        if(self.time > TM + DIFTIME)
        {
            TM = self.time;
            NC=NC+1;
            if(NC > 9)
            {
                KEY[0].Number = random(1,9);
                NC=1;
            }
        }
        
    }]
    
   HackItKey2[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        // see if current number matches random number
        if(Integer(NC) != KEY[1].Number){RED = true;}
        else
        {
            RED = false;
            //see if current number is pressed
            if(self.key_pressed = KEY[1].Number)
            {
                PlaySound("button2.wav");
                // set the text
                KEY[1].Text = StringCopy(KEY[1].Number);
                // set the next random number
                KEY[2].Number = random(1,9);
                // got to next number
                NEXTKEY="HackItKey3";
                self.think="KeyDelay";
                TM = self.time;
                return 0;
            }
        }
        
        if(self.key_pressed > -1)
        {
            PlaySound("button1.wav");
            self.think="HackItKey1";
        }
        
        if(RED)
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(Integer(NC),120,250,255.0,8,255,255,255);
        }
        else
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(Integer(NC),120,250,255.0,9,255,255,255);
        }
        
        DrawText("X",140,250,255.0,8,255,255,255);
        DrawText("X",160,250,255.0,8,255,255,255);
        DrawText("Press Green Key",100,280,255.0,7,255,255,255);
        
        if(self.time > TM + DIFTIME)
        {
            TM = self.time;
            NC=NC+1;
            if(NC > 9)
            {
                KEY[1].Number = random(1,9);
                NC=1;
            }
        }
        
    }]

   HackItKey3[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        // see if current number matches random number
        if(Integer(NC) != KEY[2].Number){RED = true;}
        else
        {
            RED = false;
            //see if current number is pressed
            if(self.key_pressed = KEY[2].Number)
            {
                PlaySound("button2.wav");
                // set the text
                KEY[2].Text = StringCopy(KEY[2].Number);
                // set the next random number
                KEY[3].Number = random(1,9);
                // got to next number
                NEXTKEY="HackItKey4";
                self.think="KeyDelay";
                TM = self.time;
                return 0;
            }
        }
        
        if(self.key_pressed > -1)
        {
            PlaySound("button1.wav");
            self.think="HackItKey1";
        }
        
        if(RED)
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(KEY[1].Text,120,250,255.0,8,255,255,255);
            DrawText(Integer(NC),140,250,255.0,8,255,255,255);
        }
        else
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(KEY[1].Text,120,250,255.0,8,255,255,255);
            DrawText(Integer(NC),140,250,255.0,9,255,255,255);
        }
        
        DrawText("X",160,250,255.0,8,255,255,255);
        DrawText("Press Green Key",100,280,255.0,7,255,255,255);
        
        if(self.time > TM + DIFTIME)
        {
            TM = self.time;
            NC=NC+1;
            if(NC > 9)
            {
                KEY[2].Number = random(1,9);
                NC=1;
            }
        }
        
    }]
    
    HackItKey4[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        // see if current number matches random number
        if(Integer(NC) != KEY[3].Number){RED = true;}
        else
        {
            RED = false;
            //see if current number is pressed
            if(self.key_pressed = KEY[3].Number)
            {
                PlaySound("ping.wav");
                // set the text
                KEY[3].Text = StringCopy(KEY[3].Number);
                // set the next random number
                self.think="AllHacked";
                TM=self.time;
                return 0;
            }
        }
        
        if(self.key_pressed > -1)
        {
            PlaySound("button1.wav");
            self.think="HackItKey1";
        }
        
        if(RED)
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(KEY[1].Text,120,250,255.0,8,255,255,255);
            DrawText(KEY[2].Text,140,250,255.0,8,255,255,255);
            DrawText(Integer(NC),160,250,255.0,8,255,255,255);
        }
        else
        {
            DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
            DrawText(KEY[1].Text,120,250,255.0,8,255,255,255);
            DrawText(KEY[2].Text,140,250,255.0,8,255,255,255);
            DrawText(Integer(NC),160,250,255.0,9,255,255,255);
        }
        
        DrawText("Press Green Key",100,280,255.0,7,255,255,255);
        
        if(self.time > TM + DIFTIME)
        {
            TM = self.time;
            NC=NC+1;
            if(NC > 9)
            {
                KEY[3].Number = random(1,9);
                NC=1;
            }
        }
        
    }]
   
    KeyDelay[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        if(self.key_pressed < 0)
        {
            self.think=NEXTKEY;
            TM = self.time;
        }
    }]
    
    AllHacked[()
    {
        if(not DrawTime()){self.think="TimeOut";return 0;}
        DrawText(KEY[0].Text,100,250,255.0,8,255,255,255);
        DrawText(KEY[1].Text,120,250,255.0,8,255,255,255);
        DrawText(KEY[2].Text,140,250,255.0,8,255,255,255);
        DrawText(KEY[3].Text,160,250,255.0,8,255,255,255);
        DrawText("Access Granted",100,280,255.0,7,255,255,255);
        if(self.time > TM+3)
        {
            self.think=NEXT; // set the next panel order
            SetEventState(BACK # "trig",true);// activate this panel
            return 0;
        }
    }]
    
    DrawTime[()
    {
        FONT = 10;
        if(self.time > LC+0.099)
        {
            LC = self.time;
            LEVELTIME = LEVELTIME - 0.1;            
        }
        if(LEVELTIME < 1)
        {
            return false; // times up
        }
        
        if(LEVELTIME < 120)
        {
            FONT = 8;
        }
        
        MN = Integer(LEVELTIME / 60); //minutes
        ST = Integer(LEVELTIME - (MN * 60));
        ML = Integer((LEVELTIME - Integer(LEVELTIME))*10);
        
        MNL = LeftCopy("00",2-GetStringLength(MN)) # MN ;
        STL = LeftCopy("00",2-GetStringLength(ST)) # ST;
        
        WDT = MNL # ":" # STL # ":0" # ML;
        
        DrawText(WDT,630,50,128,FONT,255,255,255);
        return true;
    }]
    
    TimeOut[()
    {
        DrawText("00:00:00",630,50,128,8,255,255,255);
        DrawText("Out of Time",200,250,255.0,8,255,255,255);
        DamagePlayer(100,"health");
        
    }]
    
}